import numpy as np

def retrosustitucion( R, vv ) :
	n, m = R.shape
	n = n-1
	vh = np.zeros( (n,) )

	vv = vv.reshape( (-1,1) )

	i = n-1
	if abs(R[i,i]) < 1e-10:
		vh[i] = 0.0
	else :
		vh[i] = vv[i,0]/R[i,i]

	i = n-2
	while i >=0 :
		suma = 0.0
		j = i+1
		while j<n :
			suma += R[i,j]*vh[j]
			j += 1
		vh[i] = ( vv[i,0] - suma )/R[i,i]
		i -= 1

	return vh
